using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Drawing;
using Syncfusion.Styles;

namespace Grid_MultiSelect
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            CustomSelectCellsMouseControllerHelper.RegisterWithGrid( this.TheGrid );
            this.TheGrid.PrepareViewStyleInfo += new Syncfusion.Windows.Forms.Grid.GridPrepareViewStyleInfoEventHandler( this.TheGrid_PrepareViewStyleInfo );

            this.LoadData();

        }

        private void LoadData()
        {
            this.TheGrid.ColCount = 0;
            this.TheGrid.SetColWidth(0, 0,20 );
            this.TheGrid.SetColWidth( 1, 1, 20 );
            this.TheGrid.ColCount = 10;
            this.SetColHeaderText();
            this.TheGrid.RowCount = 10;
            for (int i = 1; i <= 10; i++)
            {
                
                for (int j = 1; j <= TheGrid.ColCount; j++)
                {
                    if (j == 1)
                    {
                        this.AddCheckBox( i, j );
                    }
                    else
                    {
                        this.AddCell( i, j );
                    }
                }

            }
            this.AddFillerRows();
        }

        private void AddCell( int row, int col )
        {
            this.TheGrid[row, col].CellType = "Static";
            this.TheGrid[row, col].Text = "Test";
            this.TheGrid[row, col].ReadOnly = true;
        }

        private void AddCheckBox( int row, int col )
        {
            this.TheGrid[row, col].CellType = "CheckBox";
            //this.TheGrid[row, col].CellValue = 1;
            this.TheGrid[row, col].HorizontalAlignment = GridHorizontalAlignment.Center;
            this.TheGrid[row, col].ReadOnly = true;

        }

        private void SetColHeaderText()
        {
            for (int i = 2; i <= this.TheGrid.ColCount; i++)
            {
                this.TheGrid[0, i].Text = string.Concat( "Column", (i-1).ToString() );
            }

        }

        private void AddFillerRows()
        {
            int iInitRowCount = this.TheGrid.RowCount;
            this.TheGrid.RowCount += 5;

            for (int i = iInitRowCount + 1; i <= this.TheGrid.RowCount; i++)
            {
                this.TheGrid[i, 0].ImageIndex = 4;
                this.TheGrid[i, 0].Enabled = false;
                this.TheGrid[i, 0].Tag = "EMPTY";
            }

        }

        void TheGrid_MouseDown( object sender, System.Windows.Forms.MouseEventArgs e )
        {

            if (e.Button == MouseButtons.Right)
            {
                //if (this.ShowContextMenu)
                //{
                GridCurrentCell cc = this.TheGrid.CurrentCell;
                Point pt = new Point( e.X, e.Y );

                this.gridContextMenu.Show( this.TheGrid, pt );
                //}
            }
        }




        void TheGrid_ClipboardCanCopy( object sender, Syncfusion.Windows.Forms.Grid.GridCutPasteEventArgs e )
        {
            //allow single cell paste
            e.IgnoreCurrentCell = false;
            e.Result = true;
            e.Handled = true;

        }

        void TheGrid_CellClick( object sender, Syncfusion.Windows.Forms.Grid.GridCellClickEventArgs e )
        {
            if (e.ColIndex > 0 && e.MouseEventArgs.Button != MouseButtons.Right)
            {
                this.TheGrid.Model.Selections.Clear();
            }
        }

        private void TheGrid_PrepareViewStyleInfo( object sender, GridPrepareViewStyleInfoEventArgs e )
        {
            if (e.RowIndex > 0 && e.ColIndex > 0)
            {
                GridCurrentCell cc = this.TheGrid.CurrentCell;
                if (cc.ColIndex == e.ColIndex && cc.RowIndex == cc.RowIndex)
                {
                    e.Style.BackColor = this.TheGrid.AlphaBlendSelectionColor;
                }
            }
        }
 
    }
}